/**
 * @name: Marian Dobre
 * @grupa: 332CA
 */

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include "util.c"

/* Matrice creata	
	
	PA7-PA6      PA5-PA4      PA3-PA2
	
	PA1-PA0      PB0-PB1      PC6-PC7
	
	PC5-PC4      PC3-PC2      PC1-PCO	
	
*/

int main(){
	
	/* Setăm toti pinii portului 
	*A, B, C si D că pini de iesire
	*/
	DDRB = 0xFF;
	DDRA = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;
	
	/* Pentru butoane test */
	
	/* Buton sus */
	 DDRD &= ~(1 << PD4);  // pinul PD4 va fi input
	 PORTD |= (1 << PD4);  // activam rezistenta de pull-up
	 
	 /* Buton stanga */
	 DDRB &= ~(1 << PB3);  // pinul PB3 va fi input
	 PORTB |= (1 << PB3);  // activam rezistenta de pull-up
	 
	 /* Buton dreapta */
	 DDRD &= ~(1 << PD1);  // pinul PD1 va fi input
	 PORTD |= (1 << PD1);  // activam rezistenta de pull-up
	 
	  /* Buton centru */
	 DDRD &= ~(1 << PD0);  // pinul PD0 va fi input
	 PORTD |= (1 << PD0);  // activam rezistenta de pull-up
	 
	 // Buton jos
	 DDRB &= ~(1 << PB2);  // pinul PB3 va fi input
	 PORTB |= (1 << PB2);  // activam rezistenta de pull-up

	int i, j;
	int mat_led[3][3];
	int next_move = 0;
	int line = 0, col = 0;
	int once = 0;

	_WINNER winner;
	PINI ret_pd;
	
	// Initializare structura winner
	winner.winner = 0;
	winner.line = -10;
	winner.col = -10;
	winner.diag = -10;
	winner.equal = 0;
	
	// Initializare matrice de leduri
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 3; j++) {
			mat_led[i][j] = 0;
		}
	}
		
	while(1) {
	
		line = 0;
		col = 0;
		once = 0;
		
		if (winner.winner != 0) {
			break;
		}
		
		// Verificam led liber
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				if ((mat_led[i][j] == 0) && (once == 0)) {
					line = i;
					col = j;
					once = 1;
				}
			}
		}
		
		// Determinam pinul cu ledul liber
		ret_pd = check_led (line, col, next_move);
		
		// Aprindem ledul
		led_light(ret_pd);
		
		_delay_ms(500);
		
		
			// Miscare stanga, dreapta, sus, jos, selectie
			while (1) {
				
				
				// Buton dreapta
				if (!(PIND & (1 << PD1))) {
					
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						// Iteram in dreapta pana gasim un led neaprins
						do {
						// "Urcam" o line
						if (col == 2) {
							line = (line + 1) % 3;
						}
						// "Urcam" o coloana
						col = (col + 1) % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprind noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
				}
				// Buton stanga
				if (!(PINB & (1 << PB3))) {
					
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						
						// Iteram in stanga pana gasim un led neaprins
						do {
						// "Coboram" o linie
						if (col == 0) {
							line = line - 1;
							if (line < 0) line = 2;
							line= line % 3;
						}
						
						// "Coboram" o coloana
						col = col - 1;
						if (col < 0) col = 2;
						col = col % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprind noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
				}
				
				// Buton sus
				 if (!(PIND & (1 << PD4))) {
					
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						// Iteram in sus pana gasim un led neaprins
						do {
						
						// "Coboram" o coloana
						if (line == 0) {
							col = col - 1;
							if (col < 0) col = 2;
							col = col % 3;
						}
						
						// "Coboram" o linie
						line = line - 1;
						if (line < 0) line = 2;
						line = line % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprind noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
					
				 }
				 
				 // Buton jos
				 if (!(PINB & (1 << PB2))) {
				 
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						// Iteram in jos pana gasim un led neaprins
						do {
						
						// "Urcam" o coloana
						if (line == 2) {
							col = (col + 1) % 3;
						}
						
						// "Urcam" o linie
						line = (line + 1) % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprindem noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
				 }
				
				// Buton centru
				if (!(PIND & (1 << PD0))) {
					
					// Selectie led pentru jucator red
					if ((next_move % 2) == 0) {
						mat_led[line][col] = 1;
					}
					// Selectie led pentru jucator green
					else {
						mat_led[line][col] = 2;
					}
					
					winner = check_win(mat_led);
					
					next_move++;
					break;
				}
				
			}
		}
	
	
	// Felicitam castigatorul
	while (1) {
	
		next_move = winner.winner;
		
		// Daca s-a completat o linie
		if (winner.line != -10) {
		
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (winner.line, i, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
			
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (winner.line, i, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
		
		}
		
		// Daca s-a completat o coloana
		if (winner.col != -10) {
		
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, winner.col, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
			
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, winner.col, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
		
		}
		
		// Daca s-a completat diagonala principala
		if (winner.diag == 100) {
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, i, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
				
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, i, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
		}
		
		// Daca s-a completat diagonala secundara
		if (winner.diag == 200) {
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, 3-i-1, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
				
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, 3-i-1, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
		}
		
		// Egalitate
		if (winner.equal == 1) {
		
			//Start red PORT A
			for (i = 7; i >= 0; i=i-2) {
				PORTA = PORTA ^ (1 << i);	// inversăm starea ledului
			}
			
			//Start red PORT C
			for (i = 5; i >= 0; i=i-2) {
				PORTC = PORTC ^ (1 << i);	// inversăm starea ledului
			}	
			//PORTC = PORTC ^ ( 1 << PC6);
			
			//Start red PORT B
			PORTB = PORTB ^ (1 << PB0);	// inversăm starea ledului
			//PORTB = PORTB ^ (1 << PB6);
			PORTB = PORTB ^ (1 << PB7);
			
			_delay_ms(500);
			
			//Stop red port A
			for (i = 7; i >= 0; i=i-2) {
				PORTA = PORTA ^ (1 << i);	// inversăm starea ledului
			}
			
			// Stop red port C
			for (i = 5; i >= 0; i=i-2) {
				PORTC = PORTC ^ (1 << i);	// inversăm starea ledului
			}
			//PORTC = PORTC ^ ( 1 << PC6);
			
			//Stop red port B
			PORTB = PORTB ^ (1 << PB0);	// inversăm starea ledului
			//PORTB = PORTB ^ (1 << PB6);
			PORTB = PORTB ^ (1 << PB7);
			_delay_ms(500);
		
		}
	}
	
	
	return 0;
}