/**
 * @name: Marian Dobre
 * @grupa: 332CA
 */

typedef struct _full_pin {
	int pin;
	int port;
} PINI;

typedef struct _win_details {
	int winner;
	int line;
	int col;
	int diag;
	int equal;

} _WINNER;

/*Matrice leduri formata din pinii ATMEGA324PA*/
PINI check_led(int line, int col,int next_move) {
	PINI to_ret;
	/* Matricea rosie */
	if ((line == 0) && (col == 0) && ((next_move % 2) == 0)) {
		to_ret.pin = PA7;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 0) && (col == 1) && ((next_move % 2) == 0)) {
		to_ret.pin = PA5;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 0) && (col == 2) && ((next_move % 2) == 0)) {
		to_ret.pin = PA3;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 1) && (col == 0) && ((next_move % 2) == 0)) {
		to_ret.pin = PA1;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 1) && (col == 1) && ((next_move % 2) == 0)) {
		to_ret.pin = PB0;
		to_ret.port = 2;
		return to_ret;
	}else if ((line == 1) && (col == 2) && ((next_move % 2) == 0)) {
		to_ret.pin = PB6;
		to_ret.port = 2;
		return to_ret;
	}else if ((line == 2) && (col == 0) && ((next_move % 2) == 0)) {
		to_ret.pin = PC5;
		to_ret.port = 3;
		return to_ret;
	}else if ((line == 2) && (col == 1) && ((next_move % 2) == 0)) {
		to_ret.pin = PC3;
		to_ret.port = 3;
		return to_ret;
	}else if ((line == 2) && (col == 2) && ((next_move % 2) == 0)) {
		to_ret.pin = PC1;
		to_ret.port = 3;
		return to_ret;
	}
	
	/* Matrice verde */
	if ((line == 0) && (col == 0) && ((next_move % 2) == 1)) {
		to_ret.pin = PA6;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 0) && (col == 1) && ((next_move % 2) == 1)) {
		to_ret.pin = PA4;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 0) && (col == 2) && ((next_move % 2) == 1)) {
		to_ret.pin = PA2;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 1) && (col == 0) && ((next_move % 2) == 1)) {
		to_ret.pin = PA0;
		to_ret.port = 1;
		return to_ret;
	}else if ((line == 1) && (col == 1) && ((next_move % 2) == 1)) {
		to_ret.pin = PB1;
		to_ret.port = 2;
		return to_ret;
	}else if ((line == 1) && (col == 2) && ((next_move % 2) == 1)) {
		to_ret.pin = PB7;
		to_ret.port = 2;
		return to_ret;
	}else if ((line == 2) && (col == 0) && ((next_move % 2) == 1)) {
		to_ret.pin = PC4;
		to_ret.port = 3;
		return to_ret;
	}else if ((line == 2) && (col == 1) && ((next_move % 2) == 1)) {
		to_ret.pin = PC2;
		to_ret.port = 3;
		return to_ret;
	}else if ((line == 2) && (col == 2) && ((next_move % 2) == 1)) {
		to_ret.pin = PC0;
		to_ret.port = 3;
		return to_ret;
	} 
	
	to_ret.pin = -1;
	to_ret.port = -1;
	return to_ret;

}

/* Starea ledurilor inversa */
void led_light(PINI ret_pd) {

if (ret_pd.port == 1) {
		PORTA ^= ( 1 << ret_pd.pin);
}else {
	if (ret_pd.port == 2) {
		PORTB ^= ( 1 << ret_pd.pin);
	}
	else {
		if (ret_pd.port == 3) {
			PORTC ^= ( 1 << ret_pd.pin);
		}
		}
	}
}

/* Verificare finala */
_WINNER check_win(int mat_led[3][3]) {

	int once = 0;
	int i, j;
	_WINNER aux;
	int win_red, win_green, win_red_col, win_green_col;
	int win_red_diag, win_green_diag;
	
	aux.winner = 0;
	aux.line = -10;
	aux.col = -10;
	aux.diag = -10;
	aux.equal = 0;
	
	/* Verificare linii si coloane */
	for (i = 0; i < 3; i++) {
		win_red = 0;
		win_green = 0;
		win_red_col = 0;
		win_green_col = 0;
		for (j = 0; j < 3; j++) {
		
			if ((mat_led[i][j] == 2) || (mat_led[i][j] == 0)) {
				win_red = 1;
			}else if ((mat_led[i][j] == 1) || (mat_led[i][j] == 0)) {
				win_green = 1;
			}else if ((mat_led[j][i] == 2) || (mat_led[j][i] == 0)) {
				win_red_col = 1;
			}else if ((mat_led[j][i] == 1) || (mat_led[j][i] == 0)) {
				win_green_col = 1;
			}
		}
		
		if (win_red == 0) {
			aux.winner = 1;
			aux.line = i;
			return aux;
		}else if (win_green == 0) {
			aux.winner = 2;
			aux.line = i;
			return aux;
		}else if (win_green_col == 0) {
			aux.winner = 2;
			aux.col = i;
			return aux;
		}else if (win_red_col == 0) {
			aux.winner = 1;
			aux.col = i;
			return aux;
		}
	}
	

	/* Verificare diagonala principala */
	win_red_diag = 0;
	win_green_diag = 0;
	for (i = 0; i  < 3; i++) {
		if ((mat_led[i][i] == 2) || (mat_led[i][i] == 0)) {
			win_red_diag = 1;
		}else if ((mat_led[i][i] == 1) || (mat_led[i][i] == 0)) {
			win_green_diag = 1;
		}
	}
	
	if (win_red_diag == 0) {
		aux.winner = 1;
		aux.diag = 100;
		return aux;
	}
	
	if (win_green_diag == 0) {
		aux.winner = 2;
		aux.diag = 100;
		return aux;
	}
	
	/* Verific diagonala secundara*/
	win_red_diag = 0;
	win_green_diag = 0;
	for (i = 0; i  < 3; i++) {
		if ((mat_led[i][3-i-1] == 2) || (mat_led[i][3-i-1] == 0)) {
			win_red_diag = 1;
		}else if ((mat_led[i][3-i-1] == 1) || (mat_led[i][3-i-1] == 0)) {
			win_green_diag = 1;
		}
	}
	
	if (win_red_diag == 0) {
		aux.winner = 1;
		aux.diag = 200;
		return aux;
	}
	
	if (win_green_diag == 0) {
		aux.winner = 2;
		aux.diag = 200;
		return aux;
	}	
	
	
	/*Verificare daca a fost egalitate*/
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 3; j++) {
			if ((mat_led[i][j] == 0) && (once == 0)) {
				once = 1;
			}
		}
	}
	
	if (once == 0) {
		aux.winner = 3; aux.line = -10; aux.col = -10;
		aux.diag = -10; aux.equal = 1;
		return aux;
	}

	aux.winner = 0; aux.line = -10; aux.col = -10;
	aux.diag = -10; aux.equal = 0;
	return aux;
}
